<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procartz Enterprise 3.8                                       ***
  ***      File:  block_manuals_articles.php                               ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procartz.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	function manuals_articles($block_name) {
		global $t, $db, $table_prefix, $settings, $datetime_show_format;
		global $article_objs;
		global $article_href;

		$manual_id = get_param("manual_id");
		$t->set_file("block_body", "block_manuals_articles.html");
		
		// Set messgaes
		$t->set_var("NO_MANUAL_ARTICLES_MSG", NO_MANUAL_ARTICLES_MSG);
				
		$article_href = "manuals_article_details.php?article_id=";

		$ar = new VA_Record($table_prefix."manuals_articles");
		$ar->add_where("manual_id", INTEGER);
		$ar->set_value("manual_id", $manual_id);
		$ar->add_where("allowed_view", INTEGER);
		$ar->set_value("allowed_view", 1);
		$ar->add_textbox("article_id", INTEGER);
		$ar->add_textbox("parent_article_id", INTEGER);
		$ar->add_textbox("article_title", TEXT);
		$ar->add_textbox("friendly_url", TEXT);
		$ar->add_textbox("section_number", INTEGER);
		$ar->add_textbox("article_order", INTEGER);
		//$ar->change_property("section_number", USE_IN_ORDER, ORDER_ASC);
		//$ar->change_property("article_path", USE_IN_ORDER, ORDER_ASC);
		$ar->change_property("article_order", USE_IN_ORDER, ORDER_ASC);
		$ar->add_textbox("short_description", TEXT);

		$article_objs = array();
		$agrid = new VA_EditGrid($ar, "article grid");
		
		$articles_number = $agrid->get_db_values();
		$article_objs = array();

		if ($articles_number > 0) {
			for($i = 1; $i <= $articles_number; $i++) {
				$agrid->set_record($i);
				$article_id = $agrid->record->get_value("article_id");
				$parent_id = $agrid->record->get_value("parent_article_id");
				if (!isset($article_objs[$parent_id])) {
					$article_objs[$parent_id] = array();
				}
				$article_objs[$parent_id][] = $agrid->record;
			}
			$t->set_var("no_contents", "");
			show_level_articles(0);
		} else {
			$t->set_var("articles", "");
			$t->parse("no_contents", false);
		}

		// Get manual info
		$sql = "SELECT * FROM ".$table_prefix."manuals_list WHERE manual_id = ".$db->tosql($manual_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$t->set_var("manual_title", $db->f("manual_title"));
		}

		
		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}
	
	function show_level_articles($parent_id) {
		global $t;
		global $article_objs;
		global $article_href;
		if (isset($article_objs[$parent_id]) && is_array($article_objs[$parent_id])) {
			foreach ($article_objs[$parent_id] as $obj) {
				// Parse article
				$article_id = $obj->get_value("article_id");
				$t->set_var("article_title", $obj->get_value("article_title"));
				$section_number = $obj->get_value("section_number");
				$t->set_var("section_number", $section_number);
				$t->set_var("short_description", $obj->get_value("short_description"));
				$friendly_url = $obj->get_value("friendly_url");
				if ($friendly_url != "") {
					$href = $friendly_url;
				} else {
					$href = $article_href.$article_id;
				}
				$level = count(explode(".", $section_number));
				$t->set_var("level", $level);
				$t->set_var("article_href", $href);
				$t->parse("articles", true);
	
				show_level_articles($article_id);
			}
		}
	}
?>